<template>
    <div><div v-if="showButton" @click="buttonClicked">
        <a>Juega al Tres en Raya</a>
    </div></div>
</template>

<script>

import * as Utils from '../libs/Utils.js';

export default {
    data() {
        return { count: 0 };
    },
    computed: {
        showButton() {
            // the count = count is to force the button to update when first game is created
            // eslint-disable-next-line vue/no-side-effects-in-computed-properties
            this.count = this.count;

            /* eslint-disable no-undef */
            let buffer = kiwi.state.getActiveBuffer();
            let network = kiwi.state.getActiveNetwork();
            /* eslint-enable no-undef */

            // Don't show the button if they have a chat to them self
            if (network.nick === buffer.name) {
                return false;
            }

            // If there is no game show the button
            let game = Utils.getGame(buffer.name);
            if (!game) {
                return true;
            }

            // Decide if the button is needed or not
            let gameActive = game.getShowGame() && !game.getGameOver();
            let inviteActive = game.getInviteSent() || game.getShowInvite();
            let ret = !gameActive && !inviteActive;
            return ret;
        },
    },
    methods: {
        forceUpdateUI: function forceUpdateUI() {
            this.count++;
        },
        buttonClicked: function buttonClicked() {
            // eslint-disable-next-line no-undef
            let buffer = kiwi.state.getActiveBuffer();
            let network = buffer.getNetwork();

            if (buffer.name === network.nick) {
                return;
            }

            if (!Utils.getGame(buffer.name)) {
                Utils.newGame(network, network.nick, buffer.name);
            }
            let game = Utils.getGame(buffer.name);

            let gameActive = game.getShowGame() && !game.getGameOver();
            let inviteActive = game.getInviteSent() && game.getShowInvite();
            if (gameActive || inviteActive) {
                return;
            }

            game.setInviteSent(true);
            if (!game.getInviteTimeout()) {
                game.setInviteTimeout(window.setTimeout(() => {
                    game.setInviteTimeout(null);
                    game.setInviteSent(false);

                    // eslint-disable-next-line no-undef
                    kiwi.state.addMessage(buffer, {
                        nick: '*',
                        message: 'La invitación para ' + buffer.name +
                            ' ha terminado el tiempo de espera :( es posible que él no tenga el plugin de Tres en Raya',
                        type: 'message',
                    });
                }, 4000));
            }
            this.forceUpdateUI();
            Utils.sendData(network, buffer.name, { cmd: 'invite' });
            // eslint-disable-next-line no-undef
            kiwi.state.addMessage(buffer, {
                nick: '*',
                message: '¡' + buffer.name + ' ha sido invitado para jugar al Tres en Raya!',
                type: 'message',
            });
        },
    },
};
</script>
